/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "pyside2_qt3danimation_python.h"

// main header
#include "qt3danimation_qkeyframe_wrapper.h"

// inner classes

// Extra includes
#include <QtGui/qvector2d.h>


#include <cctype>
#include <cstring>

using namespace Qt3DAnimation;



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DAnimation_QKeyFrame_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DAnimation::QKeyFrame >()))
        return -1;

    ::Qt3DAnimation::QKeyFrame *cptr{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths
    if (numArgs == 2)
        goto Sbk_Qt3DAnimation_QKeyFrame_Init_TypeError;

    if (!PyArg_UnpackTuple(args, "QKeyFrame", 0, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return -1;


    // Overloaded function decisor
    // 0: QKeyFrame::QKeyFrame()
    // 1: QKeyFrame::QKeyFrame(QVector2D)
    // 2: QKeyFrame::QKeyFrame(QVector2D,QVector2D,QVector2D)
    if (numArgs == 0) {
        overloadId = 0; // QKeyFrame()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // QKeyFrame(QVector2D)
        } else if (numArgs == 3
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), (pyArgs[1])))
            && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), (pyArgs[2])))) {
            overloadId = 2; // QKeyFrame(QVector2D,QVector2D,QVector2D)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_Qt3DAnimation_QKeyFrame_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QKeyFrame()
        {

            if (!PyErr_Occurred()) {
                // QKeyFrame()
                cptr = new ::Qt3DAnimation::QKeyFrame();
            }
            break;
        }
        case 1: // QKeyFrame(QVector2D coords)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QVector2D cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!PyErr_Occurred()) {
                // QKeyFrame(QVector2D)
                cptr = new ::Qt3DAnimation::QKeyFrame(cppArg0);
            }
            break;
        }
        case 2: // QKeyFrame(QVector2D coords, QVector2D lh, QVector2D rh)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QVector2D cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QVector2D cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QVector2D cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (!PyErr_Occurred()) {
                // QKeyFrame(QVector2D,QVector2D,QVector2D)
                cptr = new ::Qt3DAnimation::QKeyFrame(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DAnimation::QKeyFrame >(), cptr)) {
        delete cptr;
        Py_XDECREF(errInfo);
        return -1;
    }
    if (!cptr) goto Sbk_Qt3DAnimation_QKeyFrame_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_Qt3DAnimation_QKeyFrame_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return -1;
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_coordinates(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.coordinates";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // coordinates()const
            QVector2D cppResult = const_cast<const ::Qt3DAnimation::QKeyFrame *>(cppSelf)->coordinates();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_interpolationType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.interpolationType";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // interpolationType()const
            Qt3DAnimation::QKeyFrame::InterpolationType cppResult = const_cast<const ::Qt3DAnimation::QKeyFrame *>(cppSelf)->interpolationType();
            pyResult = Shiboken::Conversions::copyToPython(*PepType_SGTP(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX])->converter, &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_leftControlPoint(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.leftControlPoint";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // leftControlPoint()const
            QVector2D cppResult = const_cast<const ::Qt3DAnimation::QKeyFrame *>(cppSelf)->leftControlPoint();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_rightControlPoint(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.rightControlPoint";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // rightControlPoint()const
            QVector2D cppResult = const_cast<const ::Qt3DAnimation::QKeyFrame *>(cppSelf)->rightControlPoint();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_setCoordinates(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setCoordinates";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QKeyFrame::setCoordinates(QVector2D)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), (pyArg)))) {
        overloadId = 0; // setCoordinates(QVector2D)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_Qt3DAnimation_QKeyFrameFunc_setCoordinates_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QVector2D cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setCoordinates(QVector2D)
            cppSelf->setCoordinates(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_Qt3DAnimation_QKeyFrameFunc_setCoordinates_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_setInterpolationType(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setInterpolationType";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QKeyFrame::setInterpolationType(Qt3DAnimation::QKeyFrame::InterpolationType)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(*PepType_SGTP(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX])->converter, (pyArg)))) {
        overloadId = 0; // setInterpolationType(Qt3DAnimation::QKeyFrame::InterpolationType)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_Qt3DAnimation_QKeyFrameFunc_setInterpolationType_TypeError;

    // Call function/method
    {
        ::Qt3DAnimation::QKeyFrame::InterpolationType cppArg0{Qt3DAnimation::QKeyFrame::ConstantInterpolation};
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setInterpolationType(Qt3DAnimation::QKeyFrame::InterpolationType)
            cppSelf->setInterpolationType(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_Qt3DAnimation_QKeyFrameFunc_setInterpolationType_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_setLeftControlPoint(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setLeftControlPoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QKeyFrame::setLeftControlPoint(QVector2D)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), (pyArg)))) {
        overloadId = 0; // setLeftControlPoint(QVector2D)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_Qt3DAnimation_QKeyFrameFunc_setLeftControlPoint_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QVector2D cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setLeftControlPoint(QVector2D)
            cppSelf->setLeftControlPoint(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_Qt3DAnimation_QKeyFrameFunc_setLeftControlPoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_Qt3DAnimation_QKeyFrameFunc_setRightControlPoint(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Qt3DAnimation::QKeyFrame *>(Shiboken::Conversions::cppPointer(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setRightControlPoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QKeyFrame::setRightControlPoint(QVector2D)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QVECTOR2D_IDX]), (pyArg)))) {
        overloadId = 0; // setRightControlPoint(QVector2D)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_Qt3DAnimation_QKeyFrameFunc_setRightControlPoint_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QVector2D cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setRightControlPoint(QVector2D)
            cppSelf->setRightControlPoint(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_Qt3DAnimation_QKeyFrameFunc_setRightControlPoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}


static const char *Sbk_Qt3DAnimation_QKeyFrame_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DAnimation_QKeyFrame_methods[] = {
    {"coordinates", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_coordinates), METH_NOARGS},
    {"interpolationType", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_interpolationType), METH_NOARGS},
    {"leftControlPoint", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_leftControlPoint), METH_NOARGS},
    {"rightControlPoint", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_rightControlPoint), METH_NOARGS},
    {"setCoordinates", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_setCoordinates), METH_O},
    {"setInterpolationType", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_setInterpolationType), METH_O},
    {"setLeftControlPoint", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_setLeftControlPoint), METH_O},
    {"setRightControlPoint", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QKeyFrameFunc_setRightControlPoint), METH_O},

    {nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DAnimation_QKeyFrame_traverse(PyObject *self, visitproc visit, void *arg)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_traverse(self, visit, arg);
}
static int Sbk_Qt3DAnimation_QKeyFrame_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType *_Sbk_Qt3DAnimation_QKeyFrame_Type = nullptr;
static SbkObjectType *Sbk_Qt3DAnimation_QKeyFrame_TypeF(void)
{
    return _Sbk_Qt3DAnimation_QKeyFrame_Type;
}

static PyType_Slot Sbk_Qt3DAnimation_QKeyFrame_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    nullptr},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DAnimation_QKeyFrame_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DAnimation_QKeyFrame_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DAnimation_QKeyFrame_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DAnimation_QKeyFrame_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DAnimation_QKeyFrame_spec = {
    "2:PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DAnimation_QKeyFrame_slots
};

} //extern "C"


// Type conversion functions.

// Python to C++ enum conversion.
static void Qt3DAnimation_QKeyFrame_InterpolationType_PythonToCpp_Qt3DAnimation_QKeyFrame_InterpolationType(PyObject *pyIn, void *cppOut) {
    *reinterpret_cast<::Qt3DAnimation::QKeyFrame::InterpolationType *>(cppOut) =
        static_cast<::Qt3DAnimation::QKeyFrame::InterpolationType>(Shiboken::Enum::getValue(pyIn));

}
static PythonToCppFunc is_Qt3DAnimation_QKeyFrame_InterpolationType_PythonToCpp_Qt3DAnimation_QKeyFrame_InterpolationType_Convertible(PyObject *pyIn) {
    if (PyObject_TypeCheck(pyIn, SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX]))
        return Qt3DAnimation_QKeyFrame_InterpolationType_PythonToCpp_Qt3DAnimation_QKeyFrame_InterpolationType;
    return {};
}
static PyObject *Qt3DAnimation_QKeyFrame_InterpolationType_CppToPython_Qt3DAnimation_QKeyFrame_InterpolationType(const void *cppIn) {
    const int castCppIn = int(*reinterpret_cast<const ::Qt3DAnimation::QKeyFrame::InterpolationType *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QKeyFrame_PythonToCpp_QKeyFrame_PTR(PyObject *pyIn, void *cppOut) {
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DAnimation_QKeyFrame_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QKeyFrame_PythonToCpp_QKeyFrame_PTR_Convertible(PyObject *pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_Qt3DAnimation_QKeyFrame_TypeF())))
        return QKeyFrame_PythonToCpp_QKeyFrame_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QKeyFrame_PTR_CppToPython_QKeyFrame(const void *cppIn) {
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::Qt3DAnimation::QKeyFrame *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_Qt3DAnimation_QKeyFrame_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Qt3DAnimation_QKeyFrame_SignatureStrings[] = {
    "2:PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame(self)",
    "1:PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame(self,coords:PySide2.QtGui.QVector2D)",
    "0:PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame(self,coords:PySide2.QtGui.QVector2D,lh:PySide2.QtGui.QVector2D,rh:PySide2.QtGui.QVector2D)",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.coordinates(self)->PySide2.QtGui.QVector2D",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.interpolationType(self)->PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.InterpolationType",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.leftControlPoint(self)->PySide2.QtGui.QVector2D",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.rightControlPoint(self)->PySide2.QtGui.QVector2D",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setCoordinates(self,coords:PySide2.QtGui.QVector2D)",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setInterpolationType(self,interp:PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.InterpolationType)",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setLeftControlPoint(self,lh:PySide2.QtGui.QVector2D)",
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setRightControlPoint(self,rh:PySide2.QtGui.QVector2D)",
    nullptr}; // Sentinel

void init_Qt3DAnimation_QKeyFrame(PyObject *enclosingClass)
{
    _Sbk_Qt3DAnimation_QKeyFrame_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QKeyFrame",
        "Qt3DAnimation::QKeyFrame*",
        &Sbk_Qt3DAnimation_QKeyFrame_spec,
        &Shiboken::callCppDestructor< ::Qt3DAnimation::QKeyFrame >,
        0,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass    );
    
    auto pyType = reinterpret_cast<PyTypeObject *>(_Sbk_Qt3DAnimation_QKeyFrame_Type);
    InitSignatureStrings(pyType, Qt3DAnimation_QKeyFrame_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_Qt3DAnimation_QKeyFrame_Type), Sbk_Qt3DAnimation_QKeyFrame_PropertyStrings);
    SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_IDX]
        = reinterpret_cast<PyTypeObject *>(Sbk_Qt3DAnimation_QKeyFrame_TypeF());

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_Qt3DAnimation_QKeyFrame_TypeF(),
        QKeyFrame_PythonToCpp_QKeyFrame_PTR,
        is_QKeyFrame_PythonToCpp_QKeyFrame_PTR_Convertible,
        QKeyFrame_PTR_CppToPython_QKeyFrame);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QKeyFrame");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QKeyFrame*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QKeyFrame&");
    Shiboken::Conversions::registerConverterName(converter, "QKeyFrame");
    Shiboken::Conversions::registerConverterName(converter, "QKeyFrame*");
    Shiboken::Conversions::registerConverterName(converter, "QKeyFrame&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DAnimation::QKeyFrame).name());


    // Initialization of enums.

    // Initialization of enum 'InterpolationType'.
    SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX] = Shiboken::Enum::createScopedEnum(Sbk_Qt3DAnimation_QKeyFrame_TypeF(),
        "InterpolationType",
        "2:PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.InterpolationType",
        "Qt3DAnimation::QKeyFrame::InterpolationType");
    if (!SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX])
        return;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX],
        Sbk_Qt3DAnimation_QKeyFrame_TypeF(), "ConstantInterpolation", (long) Qt3DAnimation::QKeyFrame::InterpolationType::ConstantInterpolation))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX],
        Sbk_Qt3DAnimation_QKeyFrame_TypeF(), "LinearInterpolation", (long) Qt3DAnimation::QKeyFrame::InterpolationType::LinearInterpolation))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX],
        Sbk_Qt3DAnimation_QKeyFrame_TypeF(), "BezierInterpolation", (long) Qt3DAnimation::QKeyFrame::InterpolationType::BezierInterpolation))
        return;
    // Register converter for enum 'Qt3DAnimation::QKeyFrame::InterpolationType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX],
            Qt3DAnimation_QKeyFrame_InterpolationType_CppToPython_Qt3DAnimation_QKeyFrame_InterpolationType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Qt3DAnimation_QKeyFrame_InterpolationType_PythonToCpp_Qt3DAnimation_QKeyFrame_InterpolationType,
            is_Qt3DAnimation_QKeyFrame_InterpolationType_PythonToCpp_Qt3DAnimation_QKeyFrame_InterpolationType_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide2_Qt3DAnimationTypes[SBK_QT3DANIMATION_QKEYFRAME_INTERPOLATIONTYPE_IDX], converter);
        Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QKeyFrame::InterpolationType");
        Shiboken::Conversions::registerConverterName(converter, "QKeyFrame::InterpolationType");
        Shiboken::Conversions::registerConverterName(converter, "InterpolationType");
    }
    // End of 'InterpolationType' enum.

    qRegisterMetaType< ::Qt3DAnimation::QKeyFrame::InterpolationType >("QKeyFrame::InterpolationType");
    qRegisterMetaType< ::Qt3DAnimation::QKeyFrame::InterpolationType >("Qt3DAnimation::QKeyFrame::InterpolationType");
}
