/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/
#ifndef SBK_QNETWORKREPLYWRAPPER_H
#define SBK_QNETWORKREPLYWRAPPER_H

#define protected public

#include <QtNetwork/qnetworkreply.h>


// Extra includes
#include <qobject.h>
#include <QtNetwork/qnetworkaccessmanager.h>
#include <QtNetwork/qnetworkrequest.h>
#include <qurl.h>
#include <qbytearray.h>
#include <QList>
#include <QPair>
#include <QtNetwork/qsslconfiguration.h>
#include <QtNetwork/qsslerror.h>
#include <QtNetwork/qsslpresharedkeyauthenticator.h>
#include <qmetaobject.h>
#include <qcoreevent.h>
#include <qobjectdefs.h>
namespace PySide { class DynamicQMetaObject; }

class QNetworkReplyWrapper : public QNetworkReply
{
public:
    QNetworkReplyWrapper(QObject * parent = nullptr);
    void abort() override;
    bool atEnd() const override;
    qint64 bytesAvailable() const override;
    qint64 bytesToWrite() const override;
    bool canReadLine() const override;
    void childEvent(QChildEvent * event) override;
    void close() override;
    void connectNotify(const QMetaMethod & signal) override;
    void customEvent(QEvent * event) override;
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    void ignoreSslErrors() override;
    void ignoreSslErrorsImplementation(const QList<QSslError > & arg__1) override;
    bool isSequential() const override;
    const QMetaObject * metaObject() const override;
    bool open(QFlags<QIODevice::OpenModeFlag> mode) override;
    qint64 pos() const override;
    qint64 readData(char * data, qint64 maxlen) override;
    qint64 readLineData(char * data, qint64 maxlen) override;
    bool reset() override;
    bool seek(qint64 pos) override;
    void setReadBufferSize(qint64 size) override;
    void setSslConfigurationImplementation(const QSslConfiguration & arg__1) override;
    qint64 size() const override;
    void sslConfigurationImplementation(QSslConfiguration & arg__1) const override;
    void timerEvent(QTimerEvent * event) override;
    bool waitForBytesWritten(int msecs) override;
    bool waitForReadyRead(int msecs) override;
    qint64 writeData(const char * data, qint64 len) override;
    ~QNetworkReplyWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    inline void ignoreSslErrors(const QList<QSslError > & errors) { QNetworkReply::ignoreSslErrors(errors); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[30];
};

#endif // SBK_QNETWORKREPLYWRAPPER_H

