/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "pyside2_qtnetwork_python.h"

// main header
#include "qsslpresharedkeyauthenticator_wrapper.h"

// inner classes

// Extra includes
#include <QtNetwork/qsslpresharedkeyauthenticator.h>
#include <qbytearray.h>


#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSslPreSharedKeyAuthenticator_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSslPreSharedKeyAuthenticator >()))
        return -1;

    ::QSslPreSharedKeyAuthenticator *cptr{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QSslPreSharedKeyAuthenticator", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::QSslPreSharedKeyAuthenticator()
    // 1: QSslPreSharedKeyAuthenticator::QSslPreSharedKeyAuthenticator(QSslPreSharedKeyAuthenticator)
    if (numArgs == 0) {
        overloadId = 0; // QSslPreSharedKeyAuthenticator()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QSslPreSharedKeyAuthenticator(QSslPreSharedKeyAuthenticator)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QSslPreSharedKeyAuthenticator_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QSslPreSharedKeyAuthenticator()
        {

            if (!PyErr_Occurred()) {
                // QSslPreSharedKeyAuthenticator()
                cptr = new ::QSslPreSharedKeyAuthenticator();
            }
            break;
        }
        case 1: // QSslPreSharedKeyAuthenticator(const QSslPreSharedKeyAuthenticator & authenticator)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSslPreSharedKeyAuthenticator cppArg0_local;
            ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
            if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), pythonToCpp[0]))
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // QSslPreSharedKeyAuthenticator(QSslPreSharedKeyAuthenticator)
                cptr = new ::QSslPreSharedKeyAuthenticator(*cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSslPreSharedKeyAuthenticator >(), cptr)) {
        delete cptr;
        Py_XDECREF(errInfo);
        return -1;
    }
    if (!cptr) goto Sbk_QSslPreSharedKeyAuthenticator_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QSslPreSharedKeyAuthenticator_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return -1;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_identity(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.identity";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // identity()const
            QByteArray cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->identity();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_identityHint(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.identityHint";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // identityHint()const
            QByteArray cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->identityHint();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumIdentityLength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.maximumIdentityLength";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // maximumIdentityLength()const
            int cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->maximumIdentityLength();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumPreSharedKeyLength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.maximumPreSharedKeyLength";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // maximumPreSharedKeyLength()const
            int cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->maximumPreSharedKeyLength();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_preSharedKey(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.preSharedKey";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // preSharedKey()const
            QByteArray cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->preSharedKey();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_setIdentity(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.setIdentity";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::setIdentity(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), (pyArg)))) {
        overloadId = 0; // setIdentity(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QSslPreSharedKeyAuthenticatorFunc_setIdentity_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setIdentity(QByteArray)
            cppSelf->setIdentity(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QSslPreSharedKeyAuthenticatorFunc_setIdentity_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_setPreSharedKey(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.setPreSharedKey";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::setPreSharedKey(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), (pyArg)))) {
        overloadId = 0; // setPreSharedKey(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QSslPreSharedKeyAuthenticatorFunc_setPreSharedKey_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setPreSharedKey(QByteArray)
            cppSelf->setPreSharedKey(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QSslPreSharedKeyAuthenticatorFunc_setPreSharedKey_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.swap";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::swap(QSslPreSharedKeyAuthenticator&)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QSslPreSharedKeyAuthenticator&)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QSslPreSharedKeyAuthenticatorFunc_swap_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSslPreSharedKeyAuthenticator cppArg0_local;
        ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // swap(QSslPreSharedKeyAuthenticator&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QSslPreSharedKeyAuthenticatorFunc_swap_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticator___copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), &cppSelf);
    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSslPreSharedKeyAuthenticator_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSslPreSharedKeyAuthenticator_methods[] = {
    {"identity", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_identity), METH_NOARGS},
    {"identityHint", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_identityHint), METH_NOARGS},
    {"maximumIdentityLength", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumIdentityLength), METH_NOARGS},
    {"maximumPreSharedKeyLength", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumPreSharedKeyLength), METH_NOARGS},
    {"preSharedKey", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_preSharedKey), METH_NOARGS},
    {"setIdentity", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_setIdentity), METH_O},
    {"setPreSharedKey", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_setPreSharedKey), METH_O},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_swap), METH_O},

    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticator___copy__), METH_NOARGS},
    {nullptr, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QSslPreSharedKeyAuthenticator_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PythonToCppFunc pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), (pyArg)))) {
                // operator!=(const QSslPreSharedKeyAuthenticator & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QSslPreSharedKeyAuthenticator cppArg0_local;
                ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
                if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]), pythonToCpp))
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf !=(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
            goto Sbk_QSslPreSharedKeyAuthenticator_RichComparison_TypeError;
    }

    if (pyResult && !PyErr_Occurred())
        return pyResult;
    Sbk_QSslPreSharedKeyAuthenticator_RichComparison_TypeError:
    PyErr_SetString(PyExc_NotImplementedError, "operator not implemented.");
    return {};

}

} // extern "C"

static int Sbk_QSslPreSharedKeyAuthenticator_traverse(PyObject *self, visitproc visit, void *arg)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_traverse(self, visit, arg);
}
static int Sbk_QSslPreSharedKeyAuthenticator_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType *_Sbk_QSslPreSharedKeyAuthenticator_Type = nullptr;
static SbkObjectType *Sbk_QSslPreSharedKeyAuthenticator_TypeF(void)
{
    return _Sbk_QSslPreSharedKeyAuthenticator_Type;
}

static PyType_Slot Sbk_QSslPreSharedKeyAuthenticator_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    nullptr},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_richcompare)},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSslPreSharedKeyAuthenticator_spec = {
    "2:PySide2.QtNetwork.QSslPreSharedKeyAuthenticator",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    Sbk_QSslPreSharedKeyAuthenticator_slots
};

} //extern "C"


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR(PyObject *pyIn, void *cppOut) {
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSslPreSharedKeyAuthenticator_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR_Convertible(PyObject *pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QSslPreSharedKeyAuthenticator_TypeF())))
        return QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSslPreSharedKeyAuthenticator_PTR_CppToPython_QSslPreSharedKeyAuthenticator(const void *cppIn) {
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::QSslPreSharedKeyAuthenticator *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QSslPreSharedKeyAuthenticator_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QSslPreSharedKeyAuthenticator_COPY_CppToPython_QSslPreSharedKeyAuthenticator(const void *cppIn) {
    return Shiboken::Object::newObject(Sbk_QSslPreSharedKeyAuthenticator_TypeF(), new ::QSslPreSharedKeyAuthenticator(*reinterpret_cast<const ::QSslPreSharedKeyAuthenticator *>(cppIn)), true, true);
}

// Python to C++ copy conversion.
static void QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY(PyObject *pyIn, void *cppOut) {
    *reinterpret_cast<::QSslPreSharedKeyAuthenticator *>(cppOut) = *reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY_Convertible(PyObject *pyIn) {
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QSslPreSharedKeyAuthenticator_TypeF())))
        return QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSslPreSharedKeyAuthenticator_SignatureStrings[] = {
    "1:PySide2.QtNetwork.QSslPreSharedKeyAuthenticator(self)",
    "0:PySide2.QtNetwork.QSslPreSharedKeyAuthenticator(self,authenticator:PySide2.QtNetwork.QSslPreSharedKeyAuthenticator)",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.identity(self)->PySide2.QtCore.QByteArray",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.identityHint(self)->PySide2.QtCore.QByteArray",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.maximumIdentityLength(self)->int",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.maximumPreSharedKeyLength(self)->int",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.preSharedKey(self)->PySide2.QtCore.QByteArray",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.setIdentity(self,identity:PySide2.QtCore.QByteArray)",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.setPreSharedKey(self,preSharedKey:PySide2.QtCore.QByteArray)",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.swap(self,other:PySide2.QtNetwork.QSslPreSharedKeyAuthenticator)",
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.__copy__()",
    nullptr}; // Sentinel

void init_QSslPreSharedKeyAuthenticator(PyObject *module)
{
    _Sbk_QSslPreSharedKeyAuthenticator_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSslPreSharedKeyAuthenticator",
        "QSslPreSharedKeyAuthenticator",
        &Sbk_QSslPreSharedKeyAuthenticator_spec,
        &Shiboken::callCppDestructor< ::QSslPreSharedKeyAuthenticator >,
        0,
        0,
        0    );
    
    auto pyType = reinterpret_cast<PyTypeObject *>(_Sbk_QSslPreSharedKeyAuthenticator_Type);
    InitSignatureStrings(pyType, QSslPreSharedKeyAuthenticator_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_QSslPreSharedKeyAuthenticator_Type), Sbk_QSslPreSharedKeyAuthenticator_PropertyStrings);
    SbkPySide2_QtNetworkTypes[SBK_QSSLPRESHAREDKEYAUTHENTICATOR_IDX]
        = reinterpret_cast<PyTypeObject *>(Sbk_QSslPreSharedKeyAuthenticator_TypeF());

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_QSslPreSharedKeyAuthenticator_TypeF(),
        QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR,
        is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR_Convertible,
        QSslPreSharedKeyAuthenticator_PTR_CppToPython_QSslPreSharedKeyAuthenticator,
        QSslPreSharedKeyAuthenticator_COPY_CppToPython_QSslPreSharedKeyAuthenticator);

    Shiboken::Conversions::registerConverterName(converter, "QSslPreSharedKeyAuthenticator");
    Shiboken::Conversions::registerConverterName(converter, "QSslPreSharedKeyAuthenticator*");
    Shiboken::Conversions::registerConverterName(converter, "QSslPreSharedKeyAuthenticator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSslPreSharedKeyAuthenticator).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY,
        is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY_Convertible);

    qRegisterMetaType< ::QSslPreSharedKeyAuthenticator >("QSslPreSharedKeyAuthenticator");
}
